<?php
/****  ad_base.php:  This file contains the foundational functions and objects to execute a game ****/
/***
	PHPAdventure!   Copyright (C) 2003 Steven Kollmansberger

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
***/

// for PHP < 4.2.0
if (!function_exists('is_a')) {
  function is_a( $object, $className ) {
    return ((strtolower($className) == get_class($object))
          or (is_subclass_of($object, $className)));
  }
}

if (!function_exists('file_get_contents')) {
	function file_get_contents($filename) {
    	$fd = fopen("$filename", "rb");
    	$content = fread($fd, filesize($filename));
    	fclose($fd);
    	return $content;
	}
}

function BaseURL() {
	return $_SERVER['PHP_SELF'] . "?";
}

function SendHeader() {
	global $_allobjs;

	// First, disable cache
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
	header("Cache-Control: no-store, no-cache, must-revalidate");
	header("Cache-Control: post-check=0, pre-check=0", false);
	header("Pragma: no-cache");
	// end disable cache

	$game = $_allobjs['_Game'];
	print	"<html><head>";
	if (!is_null($game->cssfile))
		print "<link type='text/css' rel='stylesheet' href='" . $game->cssfile . "'>";
	else { // default style sheet
		print "<style type='text/css'>";
		print "body { background: silver; margin-left: 10%; margin-right: 10%; margin-top: 10%; margin-bottom: 10%;}";
		print "div.statusbar { margin-top: 2em; margin-bottom: 2em; background: gray; color: white; border: solid;  border-width: thin; width: 100%; font-weight: bold;}";
		print "div.descpane { padding: 0.5em; margin-top: 2em; margin-bottom: 2em; background: #666666; color: white; border: solid;  border-width: thin; width: 100%; }";
		print "div.verbpane { margin-top: 2em; margin-bottom: 2em; background: gray; color: white; border: solid;  border-width: thin; width: 100%; }";
		print "div.sidebar { padding: 0.5em; margin-top: 2em; margin-bottom: 2em; background: gray; color: white; border: solid;  border-width: thin; width: 100%; }";
		print "div.sideinv { padding: 0.5em; margin-top: 2em; margin-bottom: 2em; background: gray; color: white; border: solid;  border-width: thin; width: 100%; }";
		print "div.continue { padding: 0.5em; margin-top: 2em; margin-bottom: 2em; background: gray; color: white; border: solid;  border-width: thin; }";
		print "div.copyright { margin-top: 2em; margin-bottom: 2em; background: silver; color: black; width: 100%; }";
		print ":link { color: rgb(0, 240, 240) }";
  		print ":visited { color: rgb(0, 240, 240) }";
		print "h3 { font-weight: bold; }";
		print "h4 { font-style: italic; font-size: 75%;}";
		print "</style>";
	}
	if (!is_null($game->title)) {
		print "<title>" . $game->title . "</title>";
	} else {
		print "<title>A PHPAdventure! Game</title>";
	}
	print "</head><body>";

	
	$title = $_allobjs['_Me']->location;

	$title = $_allobjs[$title]->Name();
	$game = $_allobjs['_Game'];
	if (!is_null($_allobjs['_item'])) {
		$titem = $_allobjs['_item'];
		$tdobj = $_allobjs['_dobj'];
		if (is_null($tdobj)) {
			$xt = " (" . $titem->verbing($_allobjs['_verb']) . ")";
		} else {
			$xt = " (" . $titem->verbIoIng($_allobjs['_verb'], $tdobj) . ")";
		}
	}
	print "<div class='statusbar'><table width=100%><tr><td align=left><h3>" . $title . $xt . "</h3></td><td align=right><h3>";
	print $game->name . " (" . $game->version . ") </h3></td></tr></table></div>";
	print "<table width=100%><tr valign=top><td align=left width=75%>";
}

function FinishPageFooter() {
	global $_allobjs;
	print "</td><td align=right><table><tr valign=top><td><div class='sidebar'>";
	$f = $_allobjs['_Game'];
	$f = $f->sysverbs;
	asort($f);
	foreach ($f as $i) {

		print "<a href='" . BaseURL() . "_sysverb=" . $i . "'>" . $i . "</a><br>";

	}
	//print "<a href='" . BaseURL() . "sysverb=quit'>Quit</a>";
	print "</div></td></tr><tr valign=bottom><td><div class='sideinv'>";
	print "<h3>Inventory</h3>";

	$me = $_allobjs['_Me'];
	$mc = $me->contains;
	asort($mc);
	foreach ($mc as $i) {

		$f =& $_allobjs[$i];
		print dynamicString($f->objRef("look", $f->aName()) . "<br>");
	}
	if (count($mc) == 0)
		print "<h4>You are carrying nothing.</h4>";

	print "</div></td></tr></table></table>";
}

function SendFooter() {
	global $_allobjs;
	print "<div class='copyright' align=center><div class='copyright'>";
	print "<h4>" . dynamicString($_allobjs['_Game']->footermsg) . "</h4>";
	print "<h4><a href='http://phpadventure.sf.net'>PHPAdventure!</a> copyright (c) 2003 <a href='mailto:steven777400@users.sourceforge.net'>Steven Kollmansberger</a></h4></div>";

	print "</body></html>";

}

function filterHtml($instr) {
	$ishtml = FALSE;
	$a = "";
	for ($i = 0; $i < strlen($instr); $i++) {
		$b = substr($instr, $i, 1);
		if ($b == "<") $ishtml = TRUE;

		if (!$ishtml) $a = $a . $b;
		if ($b == ">") $ishtml = FALSE;
	}
	return $a;
}

function dynamicString($strng) {
		// this function should find a << code >> sections and execute them
		// re-creating the needed dynamic string
		// << code >> sections should not change any state nor do any output
		// they should return what they want to appear
		// << code >> should be put in single quotes to avoid variable evaluation
		
		$newstrng = "";
		$func = "";
		$isfunc = FALSE;

		for ($i = 0; $i < strlen($strng); $i++) {
			
			if (substr($strng, $i, 2) == "<<" && $isfunc == FALSE) {
				$i++; // skip the second <

				$isfunc = TRUE;
				$func = "";
			} elseif (substr($strng, $i, 2) == ">>" && $isfunc == TRUE) {
				$isfunc = FALSE;
				$i++; // skip the second >

				// execute function and append to newstring
				$newfunc = create_function('', $func);
				$newstrng .= $newfunc();

				//$newstrng .= eval($func);
			} elseif ($isfunc == FALSE) {
				$newstrng .= substr($strng, $i, 1);
			} elseif ($isfunc == TRUE) {
				$func .= substr($strng, $i, 1);
			}
		}
		return $newstrng;
	}


/**********
	Object:  The most basic kind of thing in the game.  Objects are by default non-interactive, non-listed.

	Properties:
		$name: the short name of the object (always accessed via Name())
		$desc: the longer description of the object (shown when the object is looked at, always accessed via Desc())
		$isListed: indicates if the object should be listed in a room or container description (always accessed via isListed())
		$doVerbs: indicates which verbs are recognized by this object (note: change only in derived class, see below)
		$ioVerbs: indicates which verbs are recognized by this object (note: change only in derived class, see below)
		$linkTitle: indicates the link title.  Use NULL to default to using the Desc()
		$location: indicates the location, if the object is in one location.  Do not set this, use moveInto!!
		$contains: an array of oids inside this object.  Do not set this, use moveInto!!
			Note: Usually, you should use function isIn to recursively check this.

	Overloadable Methods:
		Name(): the short name of the object
		aName(): the indefinte version of the object short name
		theName(): the definite version of the object short name
		Desc(): the longer description of the object
		isListed(): indicates if the object should be listed in a room or container description
		doVerbVerify($verb): indicates if a given verb is acceptable to be executed with this object as the direct object.
		ioVerbVerify($verb, $dobj): indicates if a given verb is acceptable to be executed.  This object will be the indirect object.
		verbIng($verb): returns the -"ing" form of the given verb.  For the status bar.
		verbIoIng($verb, $dobj): returns the -"ing" form of the given verb.  For the status bar.
		verbDo($verb): return the command link text for a given verb with this object as the direct object
		verbIo($verb, $dobj): return the command link text for a given verb this this object as the indirect object
		doVerbHandle($verb): executes the specified verb with this object as the direct object
		ioVerbHandle($verb, &$dobj): executes the specified verb with this object as the indirect object
		contentsChanged($entered, &$obj):  Called when an object is added or removed from the contents
			entered will be TRUE if the object is added or FALSE otherwise.  obj will be the object in question.
		emitsLight(): returns TRUE if the object emits light or FALSE otherwise.
		linkTitle(): returns a string for the link tooltip.  Do not use ' or HTML

	Other Useful Methods:
		moveInto(&$dest): moves the object into the specified room or container.
		moveIntoMulti($destarray): specifies an array of destinations to put the item in. location will be null
		moveOut(): moves the object into la-la land
		isReachable($dest): indicates if the specified destination can be reached from this object
		isIn($dest): indicates if the specified destination is contained (perhaps at a deep level) within this object
		objRef($verb = "look", $title = NULL, $dobj = NULL): Generates a link to an object if the verb verifies AND the object is reachable.
			If the object verb does not verify or the object is not reachable, only the title is displayed.  No link is created.  The default title is the object's aName()
			Note that when adding links to fixed display objects, they will not be reachable.  Do not use this function except in another function.
		fixedObjRef($verb = "look", $title = NULL, $dobj = NULL): As above, but does not check reachability when generating
			links.  Note that reachability will be checked when the link is clicked.
		withMe(): returns true if the object is either in the player's possession OR in the same room as the player

	Verbs:
		look: Displays the description

	Derived Objects:
		Start with the base new object framework
		1)	If a constructor is needed, be sure to call the parent class constructor.
			i.e. if you have MyObject extends OldObject, call OldObject::OldObject() in the MyObject constructor
		2)	If you want to add a direct object verb, complete the following:
			a) In the constructor, execute array_push($doVerbs, "mydoverb");  this will add the verb as recognized by this object
			b) In doVerbVerify, add a condition to return TRUE when the verb should be allowed.  Do not make any state changes
				in this routine.
			c) In doVerbHandle, add a routine to process the request.  Note that doVerbVerify is always checked before doVerbHandle is called,
				so you do not need to duplicate the checking code.
			d) If the default phrase "verbing the object" doesn't work for your verb, add the appropriate entry into verbIng
			e) If the defulat phrase "verb the object" doesn't work for your verb, add the appropriate entry into verbDo
		3)	If you want to add an indirect object verb, complete the following:
			This would be put <x> in <y> kind of thing.  In that case, x would be the class(es) that could be the 
			direct object and y would be the classes that could be the indirect object.
			You need to change both classes to support this.
			a) For the object class(es) which will be the direct object:
				1) In the constructor, execute array_push($doVerbs, "myverb");  this will add the verb as recognized by this object
				2) In doVerbVerify, add a condition to return TRUE when the verb should be allowed.  Do not make any state changes
					in this routine.
				3) In doVerbHandle, add the following command for the verb: print $this->showIoObjs("myverb");
				4) Modify verbIng and verbDo appropriately.  Indirect object verbs should have "..." appended to the end
					of both the verbIng phrase and the verbDo phrase.  This helps users recognize that they
					will need to select an indirect object.
			b) For the object class(es) which will be the indirect object:
				1) In the constructor, execute array_push($this->ioVerbs, "myverb");  this will add the verb as recognized by the object
				2) In ioVerbVerify, add a condition to return TRUE when the verb should be allowed.  Note that the user has already selected
					a direct object (even if they haven't selected this verb yet!) and that direct object will be supplied.
				3) In ioVerbHandle, add a routine to process the request.  The direct object will be supplied.  As before, both
					doVerbVerify on the direct object and ioVerbVerify on the indirect object have been called, so no
					check duplication is needed.
				4) If the default phrase "myverb direct_object indirect_object" doesn't work for your verb, add the appropriate entry
					into verbIo.



***********/
class Object {
	var $location;  // NEVER set this!  ALWAYS use moveInto!
	var $contains; // NEVER set this!  ALWAYS use moveInto!
	var $name;
	var $desc;
	var $oid;
	var $doVerbs;
	var $ioVerbs;
	var $isListed;
	var $linkTitle;

	function Name() { return $this->name; /* . ($this->emitsLight() ? " (illuminating)" : "") */ }
	function aName() {
		$a = strtoupper($this->Name());
		if ($a[0] == 'A' || $a[0] == 'E' || $a[0] == 'I' || $a[0] == 'O' || $a[0] == 'U') {
			return "an " . $this->Name();
		} else
		return "a " . $this->Name();
	}
	function theName() { return "the " . $this->Name(); }
	function Desc() { return $this->desc; }



	function emitsLight() { return FALSE; }

	function linkTitle() {
		if (is_null($this->linkTitle))
			return filterHtml(str_replace("'", "&#039;", $this->Desc()));
		else
			return $this->linkTitle;
	}

	function Object() {
		global $_allobjs;

		$this->location = NULL;
		$this->contains = array();
		$this->doVerbs = array("look");
		$this->ioVerbs = array();
		$this->isListed = FALSE;

		//$this->oid = count($_allobjs);
		//$_allobjs[$this->oid] =& $this;

	}
	function isListed() {
		return $this->isListed;
	}
	function objRef($verb = "look", $title = NULL, $dobj = NULL, $misc = NULL) {
		global $_allobjs;
		$ml = $_allobjs['_Me']->location;
		$f = FALSE;


		// huge conjuction - check to see if all verbs verify for both normal and io types!!
		
		

		if (( $this->doVerbVerify($verb) || !is_null($dobj) ) &&
			($_allobjs['_Me']->isReachable($this) || $_allobjs[$ml]->isReachable($this) )
			&& ($_allobjs['_Me']->isReachable($dobj) || $_allobjs[$ml]->isReachable($dobj) || is_null($dobj) )
			&& ( is_null($dobj) || ($this->ioVerbVerify($verb, $dobj) && $dobj->doVerbVerify($verb))  ) ) {

			// whew!
			$a = "<a href='" . BaseURL() . "_item=";

			$a = $a . $this->oid;
			$a = $a . "&_verb=" . $verb;
			if (!is_null($dobj)) {
				$a = $a . "&_dobj=" . $dobj->oid;
			}
			if (!is_null($misc)) {
				$a = $a . "&_misc=" . $misc;
			}
			$a = $a . "'";
			if ($verb == "look") $a = $a . "title='" . $this->linkTitle() . "'";
			$a = $a . ">";
			$f = TRUE;
		}
		if (is_null($title)) {
			$a = $a . $this->Name();
		} else {
			$a = $a . $title;
		}
		if ($f) {
			$a = $a . "</a>";
		}
		return $a;
	}
	
	function fixedObjRef($verb = "look", $title = NULL, $dobj = NULL) {
		global $_allobjs;
		if ($this->doVerbVerify($verb)) {
			$a = "<a href='" . BaseURL() . "_item=";

			$a = $a . $this->oid;
			$a = $a . "&_verb=" . $verb;
			if (!is_null($dobj)) {
				$a = $a . "&_dobj=" . $dobj->oid;
			}
			$a = $a . "'";
			if ($verb == "look") $a = $a . "title='" . $this->linkTitle() . "'";
			$a = $a . ">";
			/* $a = $a . "'>"; */
		}
		if (is_null($title)) {
			$a = $a . $this->Name();
		} else {
			$a = $a . $title;
		}
		if ($this->doVerbVerify($verb)) {
			$a = $a . "</a>";
		}
		return $a;
	}

	function _localIoVerbs($except = NULL, $th) {// th is "this" except that this function is recursive across objects so this is lost
		global $_allobjs;
		$allverbs = array();

		foreach ($this->contains as $i) {
			$i = $_allobjs[$i];
			if ( ($_allobjs[$_allobjs['_Me']->location]->isReachable($i) || $_allobjs['_Me']->isReachable($i)) && (/*!$_allobjs[$th]->isIn($i) &&*/ $th->oid != $i->oid) ) {
				foreach ($i->ioVerbs as $i2) {

					if ($i2 != $except &&  $i->ioVerbVerify($i2, $th) && $i->oid != $th->oid) array_push($allverbs, $i2); // $this->doVerbVerify($i2) &&
				}

				$allverbs = array_merge($allverbs, $i->_localIoVerbs($except, $th));
			}
		}

		return $allverbs;
	}


	function _ioVerbs($except = NULL) {
		global $_allobjs;
		$allverbs = array();

		// ioverbs come from all surfaces that I can reach

		// ioverbs come from me

		$allverbs = array_merge($_allobjs[$_allobjs['_Me']->location]->_localIoVerbs($except, $this), $_allobjs['_Me']->_localIoVerbs($except, $this));


		$allverbs =  array_unique($allverbs);

		$oc = count($allverbs);

		foreach ($allverbs as $i => $j) {

			if ($this->doVerbVerify($allverbs[$i]) == FALSE && !is_null($allverbs[$i])) {

				unset($allverbs[$i]);



			}
		}

		return $allverbs;
	}

	function _localIoObjs($verb, $th) { // th is "this" except that this function is recursive across objects so this is lost
		global $_allobjs;
		$ioobjs = array();

		foreach ($this->contains as $i2) {
			$i =& $_allobjs[$i2];
			$tmp = $_allobjs[$_allobjs['_Me']->location];
			if (($tmp->isReachable($i) || $_allobjs['_Me']->isReachable($i)) && (/*!$_allobjs[$th]->isIn($i) &&*/ $th->oid != $i->oid) ) {

				if ($i->ioVerbVerify($verb, $th) && $th->oid != $i->oid) array_push($ioobjs, $i->oid); // $this->doVerbVerify($verb) &&
				$ioobjs = array_merge($ioobjs, $i->_localIoObjs($verb, $th));
			}

		}
		return $ioobjs;
	}

	function _ioObjs($verb) {
		global $_allobjs;
		$ioobjs = array();

		$ioobjs = array_merge($_allobjs[$_allobjs['_Me']->location]->_localIoObjs($verb, $this), $_allobjs['_Me']->_localIoObjs($verb, $this));

		$ioobjs =  array_unique($ioobjs);
		/*for ($i = 0; $i < count($ioobjs); $i++) {
			if ($this->doVerbVerify($allverbs[$i]) == FALSE) {
				unset($allverbs[$i]);
				$i--;
			}
		}*/
		return $ioobjs;
	}
	
	function withMe() {
		global $_allobjs;
		return ($this->isin($_allobjs['_Me']) || $this->isin($_allobjs[$_allobjs['_Me']->location]));
	}

	function showIoObjs($verb) {
		// for this as the direct object
		global $_allobjs;
		$ioobjs = $this->_ioObjs($verb);
		asort($ioobjs);

		if (count($ioobjs) == 0) return "";

		$a = "<div class='verbpane'><table align=center cellpadding=5><tr>";
		$icnt = 0;
		foreach ($ioobjs as $i) {
			$i = $_allobjs[$i];
			$icnt = $icnt + 1;
			$a = $a . "<td ";
			if ($icnt % 2 == 0) $a = $a . "align=right";
			if ($icnt % 2 == 1 && $icnt < count($ioobjs)) $a = $a . "align=left";
			$a = $a . ">";
			$a = $a . $i->objRef($verb, $i->verbIo($verb, $this), $this) . "</td>";
			if ($icnt % 2 == 0) $a = $a . "</tr><tr>";
		}
		$a = $a . "</tr></table></div>";
		return $a;
	}

	function showVerbs($except = NULL) {

		//$allverbs = array_merge($this->doVerbs, $this->ioVerbs);

		$allverbs = array();
		foreach ($this->doVerbs as $i) {

			if ($i != $except && $this->doVerbVerify($i)) array_push($allverbs, $i);
		}

		$allverbs = array_merge($allverbs, $this->_ioVerbs($except));

		asort($allverbs);
		if (count($allverbs) == 0) return "";
		$a = "<div class='verbpane'><table align=center cellpadding=5><tr>";
		$icnt = 0;
		foreach ($allverbs as $i) {

			$a = $a . "<td ";
			$icnt = $icnt + 1;
			if ($icnt % 2 == 0) $a = $a . "align=right";
			if ($icnt % 2 == 1 && $icnt < count($allverbs)) $a = $a . "align=left";
			$a = $a . ">";
			$a = $a . $this->objRef($i, $this->verbDo($i)) . "</td>";
			if ($icnt % 2 == 0) $a = $a . "</tr><tr>";

		}
		$a = $a . "</tr></table></div>";

		return $a;
	}

	function contentsChanged($entered, &$obj) {
		// no behavior by default

	}

	function _moveOut(&$obj) {

		if (isset($this->contains[$obj->oid])) {
			unset($this->contains[$obj->oid]);
			$this->contentsChanged(FALSE, $obj);
		}


	}
	
	function moveOut() {
		global $_allobjs;
		if (!is_null($this->location) ) {
			$_allobjs[$this->location]->_moveOut($this);
		} else {
			// could be in many locations, must check them all
			foreach ($_allobjs as $k => $i) {
				if (is_a($i, "Object")) $i->_moveOut($this);
			}
		}
	}

	function moveInto(&$dest) {
		global $_allobjs;
		$destoid = $dest->oid;


		// if (array_key_exists($destoid, $_allobjs) == false) {
		//if (is_null($dest) == FALSE) {
		// null not supported, use moveOut
			if (!is_a($dest, "Object")) {
				trigger_error("Invalid destination ".$destoid." for moveInto in " . $this->name . " (". $this->oid . ")");
			}
		//}
		/* if (!is_null($this->location) ) {
			$oldcont =& $_allobjs[$this->location];
			$oldcont->_moveOut($this);
		} */
		$this->moveOut();
		//if (is_null($dest) == FALSE) {
			$this->location = $destoid;
			if ($this->oid != '_Me' && !isset($dest->contains[$this->oid])) {// we don't store ourselves inside things
				$dest->contains[$this->oid] = $this->oid;
				$dest->contentsChanged(TRUE, $this);
			}
		/* } else {
			$this->location = NULL;
			unset($this->location);
		} */



	}
	
	function moveIntoMulti($destarray) {
		global $_allobjs;
		$this->moveOut();
		$this->location = NULL;
		foreach ($destarray as $tdest) {
			$dest =& $_allobjs[$tdest->oid];
			$destoid = $dest->oid;
			if (!is_a($dest, "Object")) {
				trigger_error("Invalid destination ".$destoid." for moveInto in " . $this->name . " (". $this->oid . ")");
			}
			if ($this->oid != '_Me' && !isset($dest->contains[$this->oid])) {// we don't store ourselves inside things
				$dest->contains[$this->oid] = $this->oid;
				$dest->contentsChanged(TRUE, $this);
			}
		}

	}

	function isReachable($dest) {
		global $_allobjs;

		if ($dest->oid == $this->oid) return TRUE;
		foreach ($this->contains as $i) {
			$f = $_allobjs[$i];
			if($f->oid == $dest->oid) return TRUE;

			if ($f->isReachable($dest)) return TRUE;
		}
		return FALSE;
	}

	function isIn($dest) {
		global $_allobjs;

		foreach ($dest->contains as $i) {
			$f = $_allobjs[$i];
			if ($f->oid == $this->oid) return TRUE;
			if ($this->isIn($f)) return TRUE;
		}
		return FALSE;
	}

	function doVerbVerify($verb) {
		if ($verb == "look") return TRUE;
		return FALSE;
	}

	function ioVerbVerify($verb, $dobj) {

		return FALSE;
	}

	function verbIng($verb) {
		switch ($verb) {
		case "look":
			return "looking at " . $this->theName();
		default:
			return $verb . "ing " . $this->theName();
		}
	}

	function verbIoIng($verb, $dobj) {
		return ucfirst($verb) . "ing " . $dobj->theName() . " -> " . $this->theName();

	}


	function verbDo($verb) {
		switch ($verb) {
		case "look":
			return "Look at " . $this->theName();
		default:
			return ucfirst($verb) . " " . $this->theName();
		}
	}

	function verbIo($verb, $dobj) {
		global $_allobjs;
		return ucfirst($verb) . " " . $dobj->theName() . " -> " .$this->theName();
	}

	function doVerbHandle($verb) {
		global $_allobjs;
		switch ($verb) {
		case "look":
			// Describe the object and show other actions available
			print "<div class='descpane'>" . dynamicString($this->Desc());
			print "</div>";
			print $_allobjs['_interlude'];
			$_allobjs['_interlude'] = "";
			print $this->showVerbs($verb);
			break;
		default:
			// Error!
			trigger_error("Unhandled doVerb " . $verb . " in " . $this->name . " (". $this->oid . ")");
		}
	}

	function ioVerbHandle($verb, &$dobj) {
		trigger_error("Unhandled ioVerb " . $verb . " in " . $this->name . " (". $this->oid . ")");
	}

};

/********
	Fuse:  Fuses provide a method for a function to be called on a regular basis.
	
	The Fuse class must be overloaded to provide the functionality.  The fuse counter ($fuseleft)
	will be decremented every turn until it reachs 0, at which point fuseProcess() will be called.
	If the fuse should execute again, fuseProcess must set fuseleft to the appropriate value.

	New/Updated Properties:
		$fuseleft:  Indicates how many turns until the fuse goes off.  Set to 0 to disable the fuse.

	New/Updated Overloadable Methods:
		fuseProcess(&$verb, &$itemoid, &$dobjoid):  This function is called when the fuse has burned down.  Note that
			it is called before anything is displayed so it should not perform any output.
			If you need output, return a string.  The system will display that output at
			the appropriate time.
			If you need to end, win or quit the game, call SendHeader() first, then
			the appropriate game function
********/
class Fuse extends Object {
	var $fuseleft;
	var $docall;
	function Fuse() {
		$this->fuseleft = 0; // disabled
		Object::Object();
	}
	function fuseProcess(&$verb, &$itemoid, &$dobjoid) {
		// do something interesting
	}
}

/********
	Game:  Contains basic game information

	New/Updated Properties:
		$name:  This comes from object, but is used here to mean the title of the game.
		$desc:  Also from object, but consists of a message for the About window
		$footermsg:  Message for the footer (e.g. copyright message) for every page
		$version: Indicates the version number of the game
		$sysverbs: Indicates system verbs handled by this object (add in constructor).
		$cssfile: Indicates the URL to a CSS file to apply to every page
		$title: Indicates what to show in the browser's title bar
		$quitmsg: Displayed when the game is quit.
		$diemsg:  Displayed when the player dies.
		$winmsg: Displayed when the player wins.
		$initmsg: Displayed when the game is first started.


	New/Updated Overloadable Methods:
		handleSysVerb($verb): This handles the request of a system verb.  System verbs appear in the right side panel and may be called
			at any time.
		quitMsg(): This displays the results of quitting.  Can overload if you want to have an interactive quit screen.
			returns TRUE to quit or FALSE to cancel the quit.
		turnStart(&$verb, &$itemoid, &$dobjoid):  This function is called at the beginning of every request that isn't a system verb or a null verb.
			Note that some of the parameters may be unset.  You may make changes to the parameters, but they will
			still have to pass normal checks.
			NOTICE:  This function is called early on and should NOT directly output anything!  Instead, return any string and the system will
			output it after the header is sent.
			NOTICE:  This function handles fuses, so if you overload it, be sure to call parent::turnStart
			otherwise fuses will not work.
		death(): This function is called when the player dies.  it is basically the same as quitting.
		dieMsg(): This displays the results of dying. returns TRUE to quit or FALSE to cancel the death.
		endGame():  Ends the game without displaying any message.
		win():  Ends the game in a win condition
		init():  Called at the beginning of a game.  Returns text to be displayed.

	New/Updated Verbs:
		Quit:  Ends the game
		About:  Displays an about message
		Restart:  Restarts the game


********/
class Game extends Object {
	// extends Object only to be stored

	var $version;
	var $sysverbs;
	var $cssfile;
	var $title;
	var $quitmsg;
	var $diemsg;
	var $winmsg;
	var $footermsg;
	var $initmsg;

	function init() {
		return $this->initmsg;
	}

	function Game() {
		Object::Object();
		$this->sysverbs = array("About", "Quit", "Restart", "Restore", "Save", "Wait"); // save handled in ad_main
		$this->quitmsg = "Your session has been terminated.  Thank you for playing.";
		$this->diemsg = "You have died!";
		$this->winmsg = "Congratulations, you have won the game!";
		$this->initmsg = "It was a dark and stormy night...";
	}

	function quitMsg() {
		print "<table align=center width=40%><tr><td><div align=center class='continue'>" . dynamicString($this->quitmsg) . "</div></td></tr></table>";
		print "</td></tr></table>";
		return TRUE;
	}

	function dieMsg() {
		print "<table align=center width=40%><tr><td><div align=center class='continue'>" . dynamicString($this->diemsg) . "</td></tr></table>";
		print "</td></tr></table>";
		return TRUE;
	}
	
	function winMsg() {
		print "<table align=center width=40%><tr><td><div align=center class='continue'>" . dynamicString($this->winmsg) . "</td></tr></table>";
		print "</td></tr></table>";
		return TRUE;
	}

	function death() {
		if ($this->dieMsg() == false) return;
		$this->endGame();
	}
	
	function win() {
		if ($this->winMsg() == false) return;
		$this->endGame();
	}
	
	function endGame() {
		$_SESSION = array();
		session_destroy();
		print $this->showVerbs(array("Quit", "Save", "Wait"));
		SendFooter();
		exit();
	}

	function turnEnd($verb, $itemoid, $dobjoid) {
		/* global $_allobjs;
		$r = "";

		// Handle fuses
		foreach ($_allobjs as $i2) {
			$i =& $_allobjs[$i2->oid];

		}
		return $r; */
	}

	function turnStart(&$verb, &$itemoid, &$dobjoid) {
		global $_allobjs;
		$r = "";

		// Handle fuses
		foreach ($_allobjs as $i2) {
			$i =& $_allobjs[$i2->oid];

			if (is_a($i, "Fuse")) {

				if ($i->fuseleft > 0) {
					$i->fuseleft -= 1;

					if ($i->fuseleft == 0) {
						$r2 = $i->fuseProcess($verb, $itemoid, $dobjoid);

						if (!is_null($r2) && strlen($r2) > 0) {
							$r = $r . "<div class='descpane'>" . $r2 . "</div>";
						}

					}
				}
			}
		}
		// handle npcs
		foreach ($_allobjs as $i2) {
			$i =& $_allobjs[$i2->oid];
			if (is_a($i, "NPC")) {
				//if ($i->withMe()) {

					$r2 = $i->NPCDaemon($verb, $itemoid, $dobjoid, $i->withMe());
					if (!is_null($r2) && strlen($r2) > 0) {
						$r = $r . "<div class='descpane'>" . $r2 . "</div>";
					}
				//}
			}

		}
		return $r;
	}

	function handleSysVerb($verb) {
		global $_allobjs;
		switch ($verb) {
		case 'init':
			$f = $this->init();
			print "<div class='descpane'>" . dynamicString($f) . "</div>";
			break;
		case 'Quit':
			if ($this->quitMsg() == false) return;
			$this->endGame();
		case 'Restore':
			print "<div class='descpane'>";
			print "<form enctype='multipart/form-data' action='". BaseURL() . "_sysverb=truerestore' method='POST'>";
			// print "<input type='hidden" name="MAX_FILE_SIZE" value="30000">
			print "Select the file to restore from: <input name='savefile' type='file'> ";
			print "<input type='submit' value='Restore'>";
			print "</form></div>";
			break;
		case 'About':
			// Display game and system about info
			print "<div class='descpane'><h3>You are playing " . dynamicString($this->Name()) . "</h3>";
			print dynamicString($this->Desc());
			print "</div><div class='descpane'><h3>This game uses PHPAdventure! version 1.1</h3>";
			print "<a href='http://phpadventure.sf.net'>PHPAdventure!</a> is copyright (c) 2003 <a href='mailto:steven777400@users.sourceforge.net'>Steven Kollmansberger</a> and is released under the <a href='http://www.gnu.org/licenses/gpl.html'>GNU General Public License</a>.  ";
			print "<br><br>PHPAdventure! is designed to bridge the gap between interactive fiction and the web while leaving behind the numerous problems associated with a parser.  Adventure games should be easy to write and fun to play, and that's what PHPAdventure! hopes to do.";
			print "<br><br>Many aspects of PHPAdventure! were based on TADS, the text adventure development system.";
			print "</div>";
			break;
		case 'Restart':
			$_SESSION = array();
			session_destroy();
			print "<head><meta http-equiv='refresh' content='0; URL=" . $_SERVER['PHP_SELF'] . "'></head>";
			print "<div class='continue'><a href='" . $_SERVER['PHP_SELF'] . "'>Redirect</a></div></td></tr></table>";
			exit();
		}
	}

	function showVerbs($except = NULL) {

		//$allverbs = array_merge($this->doVerbs, $this->ioVerbs);

		$allverbs = array();
		foreach ($this->sysverbs as $i) {
			if (in_array($i, $except) == FALSE) array_push($allverbs, $i);
		}

		asort($allverbs);
		if (count($allverbs) == 0) return "";
		$a = "<div class='verbpane'><table align=center cellpadding=5><tr>";
		$icnt = 0;
		foreach ($allverbs as $i) {
			$icnt = $icnt + 1;
			$a = $a . "<td ";
			//if ($icnt % 2 == 0) $a = $a . "align=right";
			//if ($icnt % 2 == 1 && $icnt < count($allverbs)) $a = $a . "align=left";
			$a = $a . ">";
			$a = $a . "<a href='" . BaseURL() . "_sysverb=" . $i . "'>" . $i . "</a></td>";
			//if ($icnt % 2 == 0) $a = $a . "</tr><tr>";


		}
		$a = $a . "</tr></table></div>";

		return $a;
	}

}

/**** end ad_base.php ****/

?>
